package com.sun.corba.se.impl.dynamicany;

import org.omg.DynamicAny.DynAnyPackage.TypeMismatch;
import java.math.BigDecimal;
import java.math.BigInteger;
import org.omg.DynamicAny.DynAnyPackage.InvalidValue;
import org.omg.CORBA.TypeCodePackage.BadKind;
import org.omg.CORBA.TypeCode;
import com.sun.corba.se.spi.orb.ORB;
import org.omg.CORBA.Any;
import org.omg.DynamicAny.DynFixed;

public class DynFixedImpl extends DynAnyBasicImpl implements DynFixed
{
    private DynFixedImpl() {
        this(null, (Any)null, false);
    }
    
    protected DynFixedImpl(ORB orb, Any any, boolean b) {
        super(orb, any, b);
    }
    
    protected DynFixedImpl(ORB orb, TypeCode typeCode) {
        super(orb, typeCode);
        this.index = -1;
    }
    
    public String get_value() {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        return this.any.extract_fixed().toString();
    }
    
    public boolean set_value(String s) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        int fixed_digits = 0;
        boolean n = true;
        try {
            fixed_digits = this.any.type().fixed_digits();
            this.any.type().fixed_scale();
        }
        catch (BadKind badKind) {}
        String str = s.trim();
        if (str.length() == 0) {
            throw new TypeMismatch();
        }
        String s2 = "";
        if (str.charAt(0) == '-') {
            s2 = "-";
            str = str.substring(1);
        }
        else if (str.charAt(0) == '+') {
            s2 = "+";
            str = str.substring(1);
        }
        int endIndex = str.indexOf(100);
        if (endIndex == -1) {
            endIndex = str.indexOf(68);
        }
        if (endIndex != -1) {
            str = str.substring(0, endIndex);
        }
        if (str.length() == 0) {
            throw new TypeMismatch();
        }
        int index = str.indexOf(46);
        String s3;
        int n2;
        if (index == -1) {
            s3 = null;
            n2 = str.length();
        }
        else if (index == 0) {
            str = (s3 = null);
            n2 = s3.length();
        }
        else {
            str = str.substring(0, index);
            s3 = str.substring(index + 1);
            n2 = str.length() + s3.length();
        }
        if (n2 > fixed_digits) {
            n = false;
            if (str.length() < fixed_digits) {
                s3 = s3.substring(0, fixed_digits - str.length());
            }
            else if (str.length() == fixed_digits) {
                s3 = null;
            }
            else {
                throw new InvalidValue();
            }
        }
        Object o;
        try {
            new BigInteger(str);
            if (s3 == null) {
                o = new BigDecimal(s2 + str);
            }
            else {
                new BigInteger(s3);
                o = new BigDecimal(s2 + str + "." + s3);
            }
        }
        catch (NumberFormatException ex) {
            throw new TypeMismatch();
        }
        this.any.insert_fixed(o, this.any.type());
        return n;
    }
    
    public String toString() {
        int fixed_digits = 0;
        int fixed_scale = 0;
        try {
            fixed_digits = this.any.type().fixed_digits();
            fixed_scale = this.any.type().fixed_scale();
        }
        catch (BadKind badKind) {}
        return "DynFixed with value=" + this.get_value() + ", digits=" + fixed_digits + ", scale=" + fixed_scale;
    }
}
